#include<stdio.h>
#include<stdlib.h>
#include "hbook.h"
#include<math.h>
void hbook_init(void)
{
  hlimit();
  /**************************************/
  /*           ADC Trigger              */
  /**************************************/
  hbook1(100, "ADC TRIGGER S1R", 4096, 0.0, 4095.0, 0.0);
  hbook1(101, "ADC TRIGGER S1L", 4096, 0.0, 4095.0, 0.0);
  hbook1(102, "ADC TRIGGER Finger1", 4096, 0.0, 4095.0, 0.0);
  hbook1(103, "ADC TRIGGER S2", 4096, 0.0, 4095.0, 0.0);
  hbook1(104, "ADC TRIGGER Finger2", 4096, 0.0, 4095.0, 0.0);
  hbook1(105, "ADC TRIGGER Finger3", 4096, 0.0, 4095.0, 0.0);
  hbook1(106, "ADC TRIGGER S3", 4096, 0.0, 4095.0, 0.0);
  hbook1(107, "ADC TRIGGER S4R", 4096, 0.0, 4095.0, 0.0);
  hbook1(108, "ADC TRIGGER S4L", 4096, 0.0, 4095.0, 0.0);
  hbook1(109, "ADC TRIGGER C1", 4096, 0.0, 4095.0, 0.0);
  hbook1(110, "ADC TRIGGER C2", 4096, 0.0, 4095.0, 0.0);
  hbook1(111, "ADC TRIGGER C3", 4096, 0.0, 4095.0, 0.0);

  /**************************************/
  /*           TDC Trigger              */
  /**************************************/
  hbook1(200, "TDC TRIGGER S1R", 4096, 0.0, 4095.0, 0.0);
  hbook1(201, "TDC TRIGGER S1L", 4096, 0.0, 4095.0, 0.0);
  hbook1(202, "TDC TRIGGER Finger1", 4096, 0.0, 4095.0, 0.0);
  hbook1(203, "TDC TRIGGER S2", 4096, 0.0, 4095.0, 0.0);
  hbook1(204, "TDC TRIGGER Finger2", 4096, 0.0, 4095.0, 0.0);
  hbook1(205, "TDC TRIGGER Finger3", 4096, 0.0, 4095.0, 0.0);
  hbook1(206, "TDC TRIGGER S3", 4096, 0.0, 4095.0, 0.0);
  hbook1(207, "TDC TRIGGER S4R", 4096, 0.0, 4095.0, 0.0);
  hbook1(208, "TDC TRIGGER S4L", 4096, 0.0, 4095.0, 0.0);
  hbook1(209, "TDC TRIGGER C1", 4096, 0.0, 4095.0, 0.0);
  hbook1(210, "TDC TRIGGER C2", 4096, 0.0, 4095.0, 0.0);
  hbook1(211, "TDC TRIGGER C3", 4096, 0.0, 4095.0, 0.0);
  hbook1(212, "TDC TRIGGER S1 MeanTimer",4096,0.0,4095.0,0.0);
  hbook1(213, "TDC TRIGGER S4 MeanTimer",4096,0.0,4095.0,0.0);
  
  /**************************************/
  /*           ADC Crystal              */
  /**************************************/
  hbook1(300, "ADC CRYSTAL 1", 4096, 0.0, 4095.0, 0.0);
  hbook1(301, "ADC CRYSTAL 2", 4096, 0.0, 4095.0, 0.0);
  hbook1(302, "ADC CRYSTAL 3", 4096, 0.0, 4095.0, 0.0);
  hbook1(303, "ADC CRYSTAL 4", 4096, 0.0, 4095.0, 0.0);
  hbook1(304, "ADC CRYSTAL 5", 4096, 0.0, 4095.0, 0.0);
  hbook1(305, "ADC CRYSTAL 6", 4096, 0.0, 4095.0, 0.0);
  hbook1(306, "ADC CRYSTAL 7", 4096, 0.0, 4095.0, 0.0);
  hbook1(307, "ADC CRYSTAL 8", 4096, 0.0, 4095.0, 0.0);
  hbook1(308, "ADC CRYSTAL 9", 4096, 0.0, 4095.0, 0.0);

  /**************************************/
  /*           TDC Crystal              */
  /**************************************/
  hbook1(400, "TDC CRYSTAL 1", 4096, 0.0, 4095.0, 0.0);
  hbook1(401, "TDC CRYSTAL 2", 4096, 0.0, 4095.0, 0.0);
  hbook1(402, "TDC CRYSTAL 3", 4096, 0.0, 4095.0, 0.0);
  hbook1(403, "TDC CRYSTAL 4", 4096, 0.0, 4095.0, 0.0);
  hbook1(404, "TDC CRYSTAL 5", 4096, 0.0, 4095.0, 0.0);
  hbook1(405, "TDC CRYSTAL 6", 4096, 0.0, 4095.0, 0.0);
  hbook1(406, "TDC CRYSTAL 7", 4096, 0.0, 4095.0, 0.0);
  hbook1(407, "TDC CRYSTAL 8", 4096, 0.0, 4095.0, 0.0);
  hbook1(408, "TDC CRYSTAL 9", 4096, 0.0, 4095.0, 0.0);
  
  /**************************************/
  /*         MWPC hitpattern            */
  /**************************************/
  hbook1(500, "MWPC 1-X", 48, 0.5, 48.5, 0.0);
  hbook1(501, "MWPC 1-Y", 48, 0.5, 48.5, 0.0);
  hbook1(502, "MWPC 2-X", 48, 0.5, 48.5, 0.0);
  hbook1(503, "MWPC 2-Y", 48, 0.5, 48.5, 0.0);
  hbook1(504, "MWPC 3-X", 48, 0.5, 48.5, 0.0);
  hbook1(505, "MWPC 3-Y", 48, 0.5, 48.5, 0.0);
  hbook1(506, "MWPC 4-X", 64, 0.5, 64.5, 0.0);
  hbook1(507, "MWPC 4-Y", 64, 0.5, 64.5, 0.0);
  
  /**************************************/
  /*       Beam position at MWPC        */
  /**************************************/

  /*
  hbook2(508, "Beam position at MWPC1", 48, 0.5, 48.5, 48, 0.0, 48.5, 0.0);
  hbook2(509, "Beam position at MWPC2", 48, 0.5, 48.5, 48, 0.0, 48.5, 0.0);
  hbook2(510, "Beam position at MWPC3", 48, 0.5, 48.5, 48, 0.0, 48.5, 0.0);
  hbook2(511, "Beam position at MWPC4", 64, 0.5, 64.5, 64, 0.0, 64.5, 0.0);
  */

  /**************************************/
  /*           MWPC hit wire            */
  /**************************************/
  hbook2(520,"hit wire along x",1, 0.0, 4.0, 48, 0.0, 48.5, 0.0);
  hbook2(521,"hit wire along y",1, 0.0, 4.0, 48, 0.0, 48.5, 0.0);

  /**************************************/
  /*          MWPC difference           */
  /**************************************/
  hbook2(530,"hit wire vs difference x1",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(531,"hit wire vs difference y1",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(532,"hit wire vs difference x2",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(533,"hit wire vs difference y2",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(534,"hit wire vs difference x3",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(535,"hit wire vs difference y3",48, 0.5, 48.5, 48, -10.0, 10.0, 0.0); 
  hbook2(536,"hit wire vs difference x4",64, 0.5, 64.5, 48, -10.0, 10.0, 0.0); 
  hbook2(537,"hit wire vs difference y4",64, 0.5, 64.5, 48, -10.0, 10.0, 0.0); 
  
  hbook1(540,"difference x1", 50, -20.0, 20.0, 0.0);
  hbook1(541,"difference y1", 50, -20.0, 20.0, 0.0);
  hbook1(542,"difference x2", 50, -20.0, 20.0, 0.0);
  hbook1(543,"difference y2", 50, -20.0, 20.0, 0.0);
  hbook1(544,"difference x3", 50, -20.0, 20.0, 0.0);
  hbook1(545,"difference y3", 50, -20.0, 20.0, 0.0);
  hbook1(546,"difference x4", 50, -20.0, 20.0, 0.0);
  hbook1(547,"difference y4", 50, -20.0, 20.0, 0.0);
  
  hbook1(550, "single hit position : 1-X", 48, 0.5, 48.5, 0.0);
  hbook1(551, "single hit position : 1-Y", 48, 0.5, 48.5, 0.0);
  hbook1(552, "single hit position : 2-X", 48, 0.5, 48.5, 0.0);
  hbook1(553, "single hit position : 2-Y", 48, 0.5, 48.5, 0.0);
  hbook1(554, "single hit position : 3-X", 48, 0.5, 48.5, 0.0);
  hbook1(555, "single hit position : 3-Y", 48, 0.5, 48.5, 0.0);
  hbook1(556, "single hit position : 4-X", 64, 0.5, 64.5, 0.0);
  hbook1(557, "single hit position : 4-Y", 64, 0.5, 64.5, 0.0);

  hbook1(560, "single hit position : 1-X", 48, 0.5, 48.5, 0.0);
  hbook1(561, "single hit position : 1-Y", 48, 0.5, 48.5, 0.0);
  hbook1(562, "single hit position : 2-X", 48, 0.5, 48.5, 0.0);
  hbook1(563, "single hit position : 2-Y", 48, 0.5, 48.5, 0.0);
  hbook1(564, "single hit position : 3-X", 48, 0.5, 48.5, 0.0);
  hbook1(565, "single hit position : 3-Y", 48, 0.5, 48.5, 0.0);
  hbook1(566, "single hit position : 4-X", 64, 0.5, 64.5, 0.0);
  hbook1(567, "single hit position : 4-Y", 64, 0.5, 64.5, 0.0);
  /**************************************/
  /*         MWPC multiplicity          */
  /**************************************/
  hbook1(600, "MWPC MUL 1-X", 20, -0.5, 19.5, 0.0);
  hbook1(601, "MWPC MUL 1-Y", 20, -0.5, 19.5, 0.0);
  hbook1(602, "MWPC MUL 2-X", 20, -0.5, 19.5, 0.0);
  hbook1(603, "MWPC MUL 2-Y", 20, -0.5, 19.5, 0.0);
  hbook1(604, "MWPC MUL 3-X", 20, -0.5, 19.5, 0.0);
  hbook1(605, "MWPC MUL 3-Y", 20, -0.5, 19.5, 0.0);
  hbook1(606, "MWPC MUL 4-X", 20, -0.5, 19.5, 0.0);
  hbook1(607, "MWPC MUL 4-Y", 20, -0.5, 19.5, 0.0);

  hbook1(700, "MWPC CORRELATION X", 1000, -0.02, 0.02, 0.0);
  hbook1(701, "MWPC CORRELATION Y", 1000, -0.02, 0.02, 0.0);
    
  hbook1(800,"multi hit x",1000,-0.02, 0.02, 0.0);
  hbook1(801,"multi hit y",1000,-0.02, 0.02, 0.0);
  
  /*hbook2(900, "beam distribution",48, -35., 35., 48, 1625., 1700., 0.0);*/
  hbook2(1000, "beam distribution",48, -35., 35., 48, 1625., 1700., 0.0);
}

void hbook_fill1(int i, int hai_data[])
{
  float fnum;
  fnum = (float) hai_data[i];
  hf1(i+99, fnum, 1.0); 
}  

void hbook_fill2(int i, int hai_data[])
{
  float fnum;
  fnum = (float) hai_data[i];
  hf1(i+187, fnum, 1.0); 
}  

void hbook_fill3(int i, int hai_data[])
{
  float fnum;
  fnum = (float) hai_data[i];
  hf1(i+273, fnum, 1.0); 
}  

void hbook_fill4(int i, int hai_data[])
{
  float fnum;
  fnum = (float) hai_data[i];
  hf1(i+364, fnum, 1.0); 
}

/*********************************************************/
/*                     MWPC section                      */
/*********************************************************/
int   fill_MWPC_1x( int data1 , int data2 , int data3 )
{
  int a1,a2,a3,x_1;
  int i,j,k,l;
  int b1[17],b2[17],b3[17];
  int x1s[17],x2s[17],x3s[17];
  float flag1,flag2,flag3;
  a1 = data1;
  a2 = data2;
  a3 = data3;
  for( i = 1 ; i <= 16 ; i++ )
    {
      x_1 = 0;
      b1[i] = a1%2;
      b2[i] = a2%2;
      b3[i] = a3%2;
      a1 = a1/2;
      a2 = a2/2;
      a3 = a3/2;
    }
  for( j=16 ; j >= 1 ; j-- )
    {
      x1s[17-j]=b1[j];
      x2s[17-j]=b2[j];
      x3s[17-j]=b3[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag1=(float)x1s[k];
      flag2=(float)x2s[k];
      flag3=(float)x3s[k];
      hf1(500, k,   flag1);
      hf1(500, k+16,flag2);
      hf1(500, k+32,flag3);
      x_1 = x_1 + (int)flag1 + (int)flag2 + (int)flag3;
    }         
  hf1(600,x_1,1.0);
  return x_1;
}

int   fill_MWPC_1y( int data4, int data5, int data6 )
{
  int a4,a5,a6,y_1;
  int i,j,k,l;
  int b4[17],b5[17],b6[17];
  int x4s[17],x5s[17],x6s[17];
  float flag4,flag5,flag6;
  a4 = data4;
  a5 = data5;
  a6 = data6;
  y_1=0;
  a4=data4;
  a5=data5;
  a6=data6;
  for( i=1 ; i <=16 ; i++ )
    {
      b4[i] = a4%2;
      b5[i] = a5%2;
      b6[i] = a6%2;
      a4 = a4/2;
       a5 = a5/2;
       a6 = a6/2;
    }
  for( j=1 ; j <= 16 ; j++ )
    {
      x4s[j]=b4[j];
      x5s[j]=b5[j];
      x6s[j]=b6[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag4=(float)x4s[k];
      flag5=(float)x5s[k];
      flag6=(float)x6s[k];
      hf1(501, k,   flag4);
      hf1(501, k+16,flag5);
      hf1(501, k+32,flag6);
      y_1=y_1+(int)flag4+(int)flag5+(int)flag6;  
    }  	      
  hf1(601,y_1,1.0); 
  return y_1;
}

int   fill_MWPC_2x( int data7, int data8, int data9 )
{
  int a7,a8,a9,x_2;
  int i,j,k,l;
  int b7[17],b8[17],b9[17];
  int x7s[17],x8s[17],x9s[17];
  float flag7,flag8,flag9;
  a7 = data7;
  a8 = data8;
  a9 = data9;
  x_2=0;
  for( l=1 ; l <=16 ; l++ )
    {
      b7[l] = a7%2;
      b8[l] = a8%2;
      b9[l] = a9%2;
      a7 = a7/2;
      a8 = a8/2;
      a9 = a9/2;
    }
  for( j=1 ; j <= 16 ; j++ )
    {
      x7s[j]=b7[j];
      x8s[j]=b8[j];
      x9s[j]=b9[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag7=(float)x7s[k];
      flag8=(float)x8s[k];
      flag9=(float)x9s[k];
      hf1(502, k,   flag7);
      hf1(502, k+16,flag8);
      hf1(502, k+32,flag9);
      x_2=x_2+(int)flag7+(int)flag8+(int)flag9;  
    }  	      
  hf1(602,x_2,1.0);   
  return x_2;
}

int  fill_MWPC_2y( int data10, int data11, int data12 )
{
  int a10,a11,a12,y_2;
  int i,j,k,l;
  int b10[17],b11[17],b12[17];
  int x10s[17],x11s[17],x12s[17];
  float flag10,flag11,flag12;
  a10 = data10;
  a11 = data11;
  a12 = data12;
  y_2=0;
  a10=data10;
  a11=data11;
  a12=data12;
  for( l=1 ; l <=16 ; l++ )
    {
      b10[l] = a10%2;
      b11[l] = a11%2;
      b12[l] = a12%2;
      a10 = a10/2;
      a11 = a11/2;
      a12 = a12/2;
    }
  for( j=16 ; j >= 1 ; j-- )
    {
      x10s[17-j]=b10[j];
      x11s[17-j]=b11[j];
      x12s[17-j]=b12[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag10=(float)x10s[k];
      flag11=(float)x11s[k];
      flag12=(float)x12s[k];
      hf1(503, k,   flag10);
      hf1(503, k+16,flag11);
      hf1(503, k+32,flag12);
      y_2=y_2+(int)flag10+(int)flag11+(int)flag12;  
    }  	      
  hf1(603,y_2,1.0);  
  return y_2;
}

int   fill_MWPC_3x( int data13, int data14, int data15 )
{
  int a13,a14,a15,x_3;
  int i,j,k,l;
  int b13[17],b14[17],b15[17];
  int x13s[17],x14s[17],x15s[17];
  float flag13,flag14,flag15;

  a13=data13;
  a14=data14;
  a15=data15;
  x_3=0;
  for( l=1 ; l <=16 ; l++ )
    {
      b13[l] = a13%2;
      b14[l] = a14%2;
      b15[l] = a15%2;
      a13 = a13/2;
      a14 = a14/2;
      a15 = a15/2;
    }
  for( j=1 ; j <= 16 ; j++ )
    {
      x13s[j]=b13[j];
      x14s[j]=b14[j];
      x15s[j]=b15[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag13=(float)x13s[k];
      flag14=(float)x14s[k];
      flag15=(float)x15s[k];
      hf1(504, k,   flag13);
      hf1(504, k+16,flag14);
      hf1(504, k+32,flag15);
      x_3=x_3+(int)flag13+(int)flag14+(int)flag15;  
    }  	      
  hf1(604,x_3,1.0);  
  return x_3;
}

int   fill_MWPC_3y( int data16, int data17, int data18 )
{
  
  int i,j,k,l,y_3;
  int a16,a17,a18;
  int b16[17],b17[17],b18[17];
  int x16s[17],x17s[17],x18s[17];
  float flag16,flag17,flag18;
  y_3=0;
  a16=data16;
  a17=data17;
  a18=data18;
  for( l=1 ; l <=16 ; l++ )
    {
      b16[l] = a16%2;
      b17[l] = a17%2;
      b18[l] = a18%2;
      a16 = a16/2;
      a17 = a17/2;
      a18 = a18/2;
    }
  for( j=16 ; j >= 1 ; j-- )
    {
      x16s[17-j]=b16[j];
      x17s[17-j]=b17[j];
      x18s[17-j]=b18[j];
    }
  
  for( k=1 ; k <= 16 ; k++ )
    {
      flag16=(float)x16s[k];
      flag17=(float)x17s[k];
      flag18=(float)x18s[k];
      hf1(505, k,   flag16);
      hf1(505, k+16,flag17);
      hf1(505, k+32,flag18);
      y_3=y_3+(int)flag16+(int)flag17+(int)flag18;  
    }  	      
  hf1(605,y_3,1.0);  
  return y_3;
}


int   fill_MWPC_4x( int data19, int data20, int data21 , int data22 )
{
  int a19,a20,a21,a22,x_4;
  int i,j,k,l;
  int b19[17],b20[17],b21[17],b22[17];
  int x19s[17],x20s[17],x21s[17],x22s[20];
  float flag19,flag20,flag21,flag22;

  x_4=0;
  a19=data19;
  a20=data20;
  a21=data21;
  a22=data22;
  for( l=1 ; l <=16 ; l++ )
    {
      b19[l] = a19%2;
      b20[l] = a20%2;
      b21[l] = a21%2;
      b22[l] = a22%2;
      a19 = a19/2;
      a20 = a20/2;
      a21 = a21/2;
      a22 = a22/2;
    }
  for( j=1 ; j <= 16 ; j++ )
    {
      x19s[j]=b19[j];
      x20s[j]=b20[j];
      x21s[j]=b21[j];
      x22s[j]=b22[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag19=(float)x19s[k];
      flag20=(float)x20s[k];
      flag21=(float)x21s[k];
      flag22=(float)x22s[k];
      hf1(506, k,   flag19);
      hf1(506, k+16,flag20);
      hf1(506, k+32,flag21);
      hf1(506, k+48,flag22);
      x_4=x_4+(int)flag19+(int)flag20+(int)flag21+(int)flag22;  
    }
  hf1(606,x_4,1.0);
  return x_4;
}

int   fill_MWPC_4y( int data23, int data24, int data25 , int data26 )
{
  int a23,a24,a25,a26,y_4;
  int i,j,k,l;
  int b23[17],b24[17],b25[17],b26[17];
  int x23s[17],x24s[17],x25s[17],x26s[20];
  float flag23,flag24,flag25,flag26;
  
  y_4=0;
  a23=data23;
  a24=data24;
  a25=data25;
  a26=data26;
  for( l=1 ; l <=16 ; l++ )
    {
      b23[l] = a23%2;
      b24[l] = a24%2;
      b25[l] = a25%2;
      b26[l] = a26%2;
      a23 = a23/2;
      a24 = a24/2;
      a25 = a25/2;
      a26 = a26/2;
    }
  for( j=17 ; j >= 1 ; j-- )
    {
      x23s[17-j]=b23[j];
      x24s[17-j]=b24[j];
      x25s[17-j]=b25[j];
      x26s[17-j]=b26[j];
    }
  for( k=1 ; k <= 16 ; k++ )
    {
      flag23=(float)x23s[k];
      flag24=(float)x24s[k];
      flag25=(float)x25s[k];
      flag26=(float)x26s[k];
      hf1(507, k,   flag23);
      hf1(507, k+16,flag24);
      hf1(507, k+32,flag25);
      hf1(507, k+48,flag26);
      y_4=y_4+(int)flag23+(int)flag24+(int)flag25+(int)flag26;  
    } 
  hf1(607,y_4,1.0);
  return y_4;
}
